'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = transformFile;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _jscodeshift = require('jscodeshift');

var _jscodeshift2 = _interopRequireDefault(_jscodeshift);

var _transform = require('../transform');

var _transform2 = _interopRequireDefault(_transform);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function transformFile(filename) {
  return new Promise(function (resolve, reject) {
    var file = _fs2.default.readFile(filename, function (err, source) {
      if (err) {
        reject(err);
        return;
      }
      try {
        var output = (0, _transform2.default)({
          path: file,
          source: source.toString()
        }, {
          jscodeshift: _jscodeshift2.default,
          stats: function stats() {}
        }, {});
        resolve(output.toString());
      } catch (e) {
        reject(e);
      }
    });
  });
}